
function widget:GetInfo()
  return {
    name      = "Red Annihilation Help",
    desc      = "Provides basic help on how to play Red Annihilation",
    author    = "zerver",
    date      = "Jan 2012",
    license   = "GNU GPL, v2 or later",
    layer     = 10000,
    enabled   = true,
  }
end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

local px, py = 500, 100
local sx, sy = 512, 512
local drag = false
local but = 0
local page = "bitmaps/page1.bmp"

function widget:Initialize()
  local rx,ry = Spring.GetScreenGeometry()
  px = rx / 2 - sx / 2
  py = ry / 2 - sy / 2
end 


function widget:DrawScreen()
  gl.LineWidth(1.0)

  gl.Color(1,1,1,1)
  gl.Texture(page)
  gl.MatrixMode(GL.TEXTURE)
  gl.PushMatrix()
  gl.Rotate(0, 0.0, 0.0, 1.0)
  gl.MatrixMode(GL.MODELVIEW)

  gl.PushMatrix()
  gl.Translate(px, py, 0)
  gl.Scale(sx, sy, 1)
  gl.Shape(GL.TRIANGLE_FAN, { { v = {1, 1}, t = {1, 0}},{ v = {0, 1}, t = {0, 0}},{ v = {0, 0}, t = {0, 1}},{ v = {1, 0}, t = {1, 1}}})
  gl.PopMatrix()

  gl.Texture(false)
  gl.MatrixMode(GL.TEXTURE)
  gl.PopMatrix()
  gl.MatrixMode(GL.MODELVIEW)
end


local function GetButton(x,y)
  x = x - px 
  y = (py + (sy - 1)) - y
  if 10 <= x and x <= 81 and 2 <= y and y <= 65 then
    return 1
  end
  if 100 <= x and x <= 171 and 2 <= y and y <= 65 then
    return 2
  end
  if 191 <= x and x <= 262 and 2 <= y and y <= 65 then
    return 3
  end
  if 491 <= x and x <= 510 and 2 <= y and y <= 21 then
    return 4
  end
  return 0
end 

function widget:IsAbove(x, y)
  x = x - px 
  y = (py + (sy - 1)) - y
  return 0 <= x and x <512 and 0 <= y and y < 512
end

function widget:MousePress(mx, my, mButton)
    if mButton == 1 then
        if px <= mx and mx < px + sx and py <= my and my < py + sy then
            but = GetButton(mx,my)
            if but == 0 then
              drag = true
            end
            return true
        end
    end
end

function widget:MouseRelease(mx, my, mButton)
    if mButton == 1 then
        if px <= mx and mx < px + sx and py <= my and my < py + sy then
            local lbut = but
            but = GetButton(mx,my)
            if lbut > 0 and but == lbut then
              if lbut == 1 then
                page = "bitmaps/page1.bmp"
              elseif lbut == 2 then
                page = "bitmaps/page2.bmp"
              elseif lbut == 3 then
                page = "bitmaps/page3.bmp"
              elseif lbut == 4 then
                widgetHandler:RemoveWidget(self)
              end
            end
            return true
        end
    end
    drag = false
    but = 0
end

function widget:MouseMove(mx, my, dx, dy, mButton)
    if mButton == 1 and drag then
        px = px + dx
        py = py + dy
    end
end









